/*
 * ExtensionFileFilter.java
 *
 * Created on August 2, 2006, 1:05 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sddm;

import java.io.*;

/**
 *
 * @author Erik J. Tollerud
 */
public abstract class ExtensionFileFilter extends javax.swing.filechooser.FileFilter {
    public boolean accept(File f) {
        //always show directories
        if(f.isDirectory())
            return true;
        boolean match = false;
        //Iterate over extensions
        for (String s : getExtensions()) {
            String[] splits = f.getName().split("\\.");
            boolean lessTwo = splits.length < 2;
            //set true if file has no extension and should accept extension-free files, or if it has an extension and the extension matches
            if(((lessTwo && shouldAcceptNoExtension()) || ((!lessTwo)&&splits[splits.length-1].equalsIgnoreCase(s)))) {
                match = true;
                break;
            }
        }
        return match;
    }
    public abstract String[] getExtensions();
    public abstract String getDescription();
    public abstract boolean shouldAcceptNoExtension();
    
    public static class TextFilter extends ExtensionFileFilter {
    public TextFilter() {
        }
        public String getDescription() {return "Text Files";}
        public String[] getExtensions() {
            String[] strs = {"txt"};
            return strs;
        }
        public boolean shouldAcceptNoExtension() {return true;}
    
}
}


