/*
 * ImageIOFileFilter.java
 *
 * Created on July 15, 2006, 1:06 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sddm;
import java.io.*;
import javax.imageio.*;
import javax.swing.*;
import java.util.*;

/**
 *
 * @author Erik J. Tollerud
 */
public class ImageIOFileFilter extends javax.swing.filechooser.FileFilter {
    boolean readerMode;
    boolean writerMode;
    
    /** Creates a new instance of ImageIOFileFilter */
    public ImageIOFileFilter() {
        this.readerMode = true;
        this.writerMode = false;
    }

    public ImageIOFileFilter(boolean readerMode, boolean writerMode) {
        this.readerMode = readerMode;
        this.writerMode = writerMode;
    }

    public void setReaderMode(boolean readerMode) {
        this.readerMode = readerMode;
    }

    public boolean isReaderMode() {
        return readerMode;
    }

    public void setWriterMode(boolean writerMode) {
        this.writerMode = writerMode;
    }

    public boolean isWriterMode() {
        return writerMode;
    }
    
    public boolean accept(File f) {
        boolean accept = false;
        String[] fileNames = f.getName().split("\\.");
        String suffix = fileNames[fileNames.length - 1];
        
        if (f.isFile()) {
            if (this.readerMode) {
                Iterator<ImageReader> iter = ImageIO.getImageReadersBySuffix(suffix);
                accept = iter.hasNext();
            }
            if (this.writerMode && !accept) {
                Iterator<ImageReader> iter = ImageIO.getImageReadersBySuffix(suffix);
                accept = iter.hasNext();
            }
        }
        else if (f.isDirectory())
            //TODO: test
            accept = true;
        
        return accept;
    }

    public String getDescription() {
        return "Java ImageIO supported files";
    }
    
}
