/*
 * Scalar3DModuleSetupPanel.java
 *
 * Created on August 23, 2006, 1:14 PM
 */

package sddm.modules;

import sddm.*;
import sddm.data.*;
import javax.swing.*;
import java.io.*;

/**
 *
 * @author  Erik J. Tollerud
 */
public class Scalar3DModuleSetupPanel extends SDDModuleSetupPanel {
    
    /** Creates new form Scalar3DModuleSetupPanel */
    public Scalar3DModuleSetupPanel() {
        initComponents();
    }
    
    public SDDModule makeModule(StereoCamera camera) {
        PointMap<Float> map;
        try{
            map = PointMap.loadPointsAndFloatsFromFile(new File(this.fileTextField.getText()),this.threeElemButton.isSelected(),this.fieldCheckBox.isSelected());
        } catch (FileFormatException e) {
            JOptionPane.showMessageDialog(null,"File Format problem generating Scalar3DModule - using empty PointMap: "+e,"Improper File Format",JOptionPane.ERROR_MESSAGE);
            map = new PointMap<Float>();
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(null,"File Not Found - using empty PointMap: "+e,"File Not Found",JOptionPane.ERROR_MESSAGE);
            map = new PointMap<Float>();
        }
        Scalar3DModule mod = new Scalar3DModule(map,camera);
        return mod;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        fileFormatButtons = new javax.swing.ButtonGroup();
        fileTextField = new javax.swing.JTextField();
        fileBrowseButton = new javax.swing.JButton();
        granField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        threeElemButton = new javax.swing.JRadioButton();
        fourElemButton = new javax.swing.JRadioButton();
        fieldCheckBox = new javax.swing.JCheckBox();

        setPreferredSize(new java.awt.Dimension(317, 91));
        fileTextField.setText(System.getProperty("user.home"));

        fileBrowseButton.setText("Browse...");
        fileBrowseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileBrowseButtonActionPerformed(evt);
            }
        });

        granField.setText("tester");
        granField.setValue(1);

        jLabel1.setText("File:");

        jLabel2.setText("Granularity:");

        fileFormatButtons.add(threeElemButton);
        threeElemButton.setSelected(true);
        threeElemButton.setText("3 Element");
        threeElemButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        threeElemButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        fileFormatButtons.add(fourElemButton);
        fourElemButton.setText("4 Element");
        fourElemButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        fourElemButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        fieldCheckBox.setSelected(true);
        fieldCheckBox.setText("Field? (rectangular grid)");
        fieldCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        fieldCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(threeElemButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(fourElemButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(fieldCheckBox))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .add(12, 12, 12)
                        .add(granField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 65, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(fileBrowseButton))
                    .add(fileTextField))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(threeElemButton)
                    .add(fourElemButton)
                    .add(fieldCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(fileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(fileBrowseButton)
                    .add(granField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void fileBrowseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileBrowseButtonActionPerformed
        JFileChooser jfc = new JFileChooser(new File(this.fileTextField.getText()));
        jfc.setFileSelectionMode(jfc.FILES_ONLY);
        jfc.setMultiSelectionEnabled(false);
        
        jfc.setFileFilter(new ExtensionFileFilter.TextFilter());
        
        jfc.setDialogType(jfc.OPEN_DIALOG);
        if(jfc.APPROVE_OPTION == jfc.showDialog(this,null))
            this.fileTextField.setText(jfc.getSelectedFile().getPath());
    }//GEN-LAST:event_fileBrowseButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox fieldCheckBox;
    private javax.swing.JButton fileBrowseButton;
    private javax.swing.ButtonGroup fileFormatButtons;
    private javax.swing.JTextField fileTextField;
    private javax.swing.JRadioButton fourElemButton;
    private javax.swing.JFormattedTextField granField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JRadioButton threeElemButton;
    // End of variables declaration//GEN-END:variables
    
    
    
}
